diff --git a/gnu/packages/crates-io.scm b/gnu/packages/crates-io.scm
index b8c4c7bd39..d7214e2d4f 100644
--- a/gnu/packages/crates-io.scm
+++ b/gnu/packages/crates-io.scm
@@ -5728,18 +5728,26 @@ (define-public rust-bitflags-1.3
         (file-name (string-append name "-" version ".tar.gz"))
         (sha256
          (base32 "12ki6w8gn1ldq7yz9y680llwk5gmrhrzszaa17g1sbrw2r2qvwxy"))))
-    (arguments
-     `(#:tests? #f      ; Tests require rust-1.46 or newer.
-       #:cargo-inputs
-       (("rust-compiler-builtins" ,rust-compiler-builtins-0.1)
-        ("rust-rustc-std-workspace-core" ,rust-rustc-std-workspace-core-1))
-       #:cargo-development-inputs
-       (("rust-rustversion" ,rust-rustversion-1)
-        ("rust-serde" ,rust-serde-1)
-        ("rust-serde-derive" ,rust-serde-derive-1)
-        ("rust-serde-json" ,rust-serde-json-1)
-        ("rust-trybuild" ,rust-trybuild-1)
-        ("rust-walkdir" ,rust-walkdir-2))))))
+    (arguments `(#:tests? #f ; Tests require rust-1.46 or newer.
+                         ))
+    (native-inputs `(("rust-rustversion" ,rust-rustversion-1) (
+                                                               "rust-serde" ,
+                                                                       rust-serde-1)
+                                                               (
+                                                               "rust-serde-derive" ,
+                                                                                  rust-serde-derive-1)
+                                                               (
+                                                               "rust-serde-json" ,
+                                                                                rust-serde-json-1)
+                                                               (
+                                                               "rust-trybuild" ,
+                                                                              rust-trybuild-1)
+                                                               (
+                                                               "rust-walkdir" ,
+                                                                             rust-walkdir-2)))
+    (inputs `(("rust-compiler-builtins" ,rust-compiler-builtins-0.1) (
+                                                                      "rust-rustc-std-workspace-core" ,
+                                                                                                 rust-rustc-std-workspace-core-1)))))
 
 (define-public rust-bitflags-0.9
   (package
@@ -8391,12 +8399,9 @@ (define-public rust-cast-0.2
         (base32
          "1c5z7zryj0zwnhdgs6rw5dfvnlwc1vm19jzrlgx5055alnwk952b"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:skip-build? #t
-       #:cargo-inputs
-       (("rust-rustc-version" ,rust-rustc-version-0.2))
-       #:cargo-development-inputs
-       (("rust-quickcheck" ,rust-quickcheck-0.9))))
+    (arguments `(#:skip-build? #t))
+    (native-inputs `(("rust-quickcheck" ,rust-quickcheck-0.9)))
+    (inputs `(("rust-rustc-version" ,rust-rustc-version-0.2)))
     (home-page "https://github.com/japaric/cast.rs")
     (synopsis
      "Ergonomic, checked cast functions for primitive types")
@@ -12459,19 +12464,34 @@ (define-public rust-cssparser-0.28
        (sha256
         (base32 "1h924c5g2rwlmgk8hllciyky3ih3z9vf04xz3xsp3cv1jyd5kf0x"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:skip-build? #t
-       #:cargo-inputs
-       (("rust-cssparser-macros" ,rust-cssparser-macros-0.6)
-        ("rust-dtoa-short" ,rust-dtoa-short-0.3)
-        ("rust-itoa" ,rust-itoa-0.4)
-        ("rust-matches" ,rust-matches-0.1)
-        ("rust-phf" ,rust-phf-0.8)
-        ("rust-proc-macro2" ,rust-proc-macro2-1)
-        ("rust-quote" ,rust-quote-1)
-        ("rust-serde" ,rust-serde-1)
-        ("rust-smallvec" ,rust-smallvec-1)
-        ("rust-syn" ,rust-syn-1))))
+    (arguments `(#:skip-build? #t))
+    (inputs `(("rust-cssparser-macros" ,rust-cssparser-macros-0.6) (
+                                                                    "rust-dtoa-short" ,
+                                                                                 rust-dtoa-short-0.3)
+                                                                    (
+                                                                    "rust-itoa" ,
+                                                                               rust-itoa-0.4)
+                                                                    (
+                                                                    "rust-matches" ,
+                                                                                  rust-matches-0.1)
+                                                                    (
+                                                                    "rust-phf" ,
+                                                                              rust-phf-0.8)
+                                                                    (
+                                                                    "rust-proc-macro2" ,
+                                                                                      rust-proc-macro2-1)
+                                                                    (
+                                                                    "rust-quote" ,
+                                                                                rust-quote-1)
+                                                                    (
+                                                                    "rust-serde" ,
+                                                                                rust-serde-1)
+                                                                    (
+                                                                    "rust-smallvec" ,
+                                                                                   rust-smallvec-1)
+                                                                    (
+                                                                    "rust-syn" ,
+                                                                              rust-syn-1)))
     (home-page "https://github.com/servo/rust-cssparser")
     (synopsis "Rust implementation of CSS Syntax Level 3")
     (description
@@ -13601,13 +13621,13 @@ (define-public rust-data-url-0.1
          (base32
           "176wa1n8h71iwyaxhar4sqwrgrvb5sxk26az0fy88vnxrsffjgyk"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:cargo-inputs
-       (("rust-matches" ,rust-matches-0.1))
-       #:cargo-development-inputs
-       (("rust-rustc-test" ,rust-rustc-test-0.3)
-        ("rust-serde" ,rust-serde-1)
-        ("rust-serde-json" ,rust-serde-json-1))))
+    (native-inputs `(("rust-rustc-test" ,rust-rustc-test-0.3) (
+                                                               "rust-serde" ,
+                                                                       rust-serde-1)
+                                                               (
+                                                               "rust-serde-json" ,
+                                                                                rust-serde-json-1)))
+    (inputs `(("rust-matches" ,rust-matches-0.1)))
     (home-page "https://github.com/servo/rust-url")
     (synopsis "Processing of data: URL according to WHATWG's Fetch Standard")
     (description
@@ -16336,21 +16356,21 @@ (define-public rust-encoding-0.2
         (base32
          "1v1ndmkarh9z3n5hk53da4z56hgk9wa5kcsm7cnx345raqw983bb"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:skip-build? #t
-       #:cargo-inputs
-       (("rust-encoding-index-japanese"
-         ,rust-encoding-index-japanese-1.20141219)
-        ("rust-encoding-index-korean"
-         ,rust-encoding-index-korean-1.20141219)
-        ("rust-encoding-index-simpchinese"
-         ,rust-encoding-index-simpchinese-1.20141219)
-        ("rust-encoding-index-singlebyte"
-         ,rust-encoding-index-singlebyte-1.20141219)
-        ("rust-encoding-index-tradchinese"
-         ,rust-encoding-index-tradchinese-1.20141219))
-       #:cargo-development-inputs
-       (("rust-getopts" ,rust-getopts-0.2))))
+    (arguments `(#:skip-build? #t))
+    (native-inputs `(("rust-getopts" ,rust-getopts-0.2)))
+    (inputs `(("rust-encoding-index-japanese" ,
+                                            rust-encoding-index-japanese-1.20141219) (
+                                                                                 "rust-encoding-index-korean" ,
+                                                                                                         rust-encoding-index-korean-1.20141219)
+                                                                                 (
+                                                                                 "rust-encoding-index-simpchinese" ,
+                                                                                                                  rust-encoding-index-simpchinese-1.20141219)
+                                                                                 (
+                                                                                 "rust-encoding-index-singlebyte" ,
+                                                                                                                 rust-encoding-index-singlebyte-1.20141219)
+                                                                                 (
+                                                                                 "rust-encoding-index-tradchinese" ,
+                                                                                                                  rust-encoding-index-tradchinese-1.20141219)))
     (home-page
      "https://github.com/lifthrasiir/rust-encoding")
     (synopsis "Character encoding support for Rust")
@@ -18388,8 +18408,7 @@ (define-public rust-float-cmp-0.8
          (base32
           "1i56hnzjn5pmrcm47fwkmfxiihk7wz5vvcgpb0kpfhzkqi57y9p1"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:cargo-inputs (("rust-num-traits" ,rust-num-traits-0.2))))
+    (inputs `(("rust-num-traits" ,rust-num-traits-0.2)))
     (home-page "https://github.com/mikedilger/float-cmp")
     (synopsis "Floating point approximate comparison traits")
     (description
@@ -26818,11 +26837,8 @@ (define-public rust-libm-0.2
         (base32
          "0akh56sh51adhagmk9l84dyrlz60gv8ri05xhr13i1b18czkpmy7"))))
     (build-system cargo-build-system)
-    (arguments
-     `(#:cargo-inputs
-       (("rust-rand" ,rust-rand-0.6))
-       #:cargo-development-inputs
-       (("rust-no-panic" ,rust-no-panic-0.1))))
+    (native-inputs `(("rust-no-panic" ,rust-no-panic-0.1)))
+    (inputs `(("rust-rand" ,rust-rand-0.6)))
     (home-page "https://github.com/rust-lang/libm")
     (synopsis "Libm in pure Rust")
     (description "This package provides an implementation of libm in pure Rust.")
diff --git a/guix/build-system/cargo.scm b/guix/build-system/cargo.scm
index 60c35eed07..b2d97beb2f 100644
--- a/guix/build-system/cargo.scm
+++ b/guix/build-system/cargo.scm
@@ -125,17 +125,21 @@ (define builder
                     #:target #f
                     #:guile-for-build guile))
 
+(define (cargo-input? input)
+  (match input
+    ((label (? package? p))
+     (eq? cargo-build-system (package-build-system p)))
+    (_ #f)))
+
 (define (package-cargo-inputs p)
-  (apply
-    (lambda* (#:key (cargo-inputs '()) #:allow-other-keys)
-      cargo-inputs)
-    (package-arguments p)))
+  (match (member #:cargo-inputs (package-arguments p))
+    (#f (filter cargo-input? (package-inputs p)))
+    ((_ inputs . _) inputs)))
 
 (define (package-cargo-development-inputs p)
-  (apply
-    (lambda* (#:key (cargo-development-inputs '()) #:allow-other-keys)
-      cargo-development-inputs)
-    (package-arguments p)))
+  (match (member #:cargo-development-inputs (package-arguments p))
+    (#f (filter cargo-input? (package-native-inputs p)))
+    ((_ inputs . _) inputs)))
 
 (define (crate-closure inputs)
   "Return the closure of INPUTS when considering the 'cargo-inputs' and
@@ -235,8 +239,8 @@ (define (expand-crate-sources cargo-inputs cargo-development-inputs)
 (define* (lower name
                 #:key source inputs native-inputs outputs system target
                 (rust (default-rust))
-                (cargo-inputs '())
-                (cargo-development-inputs '())
+                (cargo-inputs (filter cargo-input? inputs))
+                (cargo-development-inputs (filter cargo-input? native-inputs))
                 #:allow-other-keys
                 #:rest arguments)
   "Return a bag for NAME."
@@ -260,7 +264,9 @@ (define private-keywords
          (build-inputs `(("cargo" ,rust "cargo")
                          ("rustc" ,rust)
                          ,@(expand-crate-sources cargo-inputs cargo-development-inputs)
-                         ,@native-inputs))
+                         ,@(if (eq? native-inputs cargo-development-inputs)
+                               '()
+                               native-inputs)))
          (outputs outputs)
          (build cargo-build)
          (arguments (strip-keyword-arguments private-keywords arguments)))))
diff --git a/guix/packages.scm b/guix/packages.scm
index b3c5a00011..275cc3675c 100644
--- a/guix/packages.scm
+++ b/guix/packages.scm
@@ -660,7 +660,8 @@ (define (deprecated-package old-name p)
     (name old-name)
     (properties `((superseded . ,p)))))
 
-(define (package-field-location package field)
+(define* (package-field-location package field
+                                 #:key (value-location? #t))
   "Return the source code location of the definition of FIELD for PACKAGE, or
 #f if it could not be determined."
   (match (package-location package)
@@ -678,7 +679,10 @@ (define (package-field-location package field)
                    (let ((field (assoc field inits)))
                      (match field
                        ((_ value)
-                        (let ((loc (and=> (source-properties value)
+                        (let ((loc (and=> (source-properties
+                                           (if value-location?
+                                               value
+                                               field))
                                           source-properties->location)))
                           (and loc
                                ;; Preserve the original file name, which may be a
diff --git a/guix/scripts/style.scm b/guix/scripts/style.scm
index 86a46f693c..dccc20d880 100644
--- a/guix/scripts/style.scm
+++ b/guix/scripts/style.scm
@@ -29,6 +29,7 @@
 
 (define-module (guix scripts style)
   #:autoload   (gnu packages) (specification->package fold-packages)
+  #:autoload   (guix build-system cargo) (cargo-build-system)
   #:use-module (guix scripts)
   #:use-module ((guix scripts build) #:select (%standard-build-options))
   #:use-module (guix combinators)
@@ -212,6 +213,21 @@ (define (object->string* obj indent)
       (pretty-print-with-comments port obj
                                   #:indent indent))))
 
+(define (object-list->string lst indent)
+  (call-with-output-string
+    (lambda (port)
+      (let loop ((lst lst))
+        (match lst
+          ((obj)
+           (pretty-print-with-comments port obj
+                                       #:indent indent))
+          ((obj rest ...)
+           (pretty-print-with-comments port obj
+                                       #:indent indent)
+           (newline port)
+           (display (make-string indent #\space) port)
+           (loop rest)))))))
+
 
 ;;;
 ;;; Simplifying input expressions.
@@ -441,6 +457,49 @@ (define matches?
             (list package-inputs package-native-inputs
                   package-propagated-inputs)))
 
+
+;;;
+;;; Crates, Cargo, Rust, and all that.
+;;;
+
+(define* (rewrite-cargo-inputs package
+                               #:key (policy 'silent)
+                               (edit-expression edit-expression))
+  (when (eq? (package-build-system package) cargo-build-system)
+    (match (package-field-location package 'arguments
+                                   #:value-location? #f)
+      (#f #f)
+      (location
+       (let* ((indent (location-column location)))
+         (edit-expression
+          (pk 'loc (location->source-properties location))
+          (lambda (str)
+            (define arguments
+              (call-with-input-string (pk 'str str) read-with-comments))
+
+            (match arguments
+              (('arguments ('quasiquote lst))
+               (let ((inputs (match (member #:cargo-inputs lst)
+                               (#f '())
+                               ((_ inputs . _) inputs)))
+                     (native (match (member #:cargo-development-inputs lst)
+                               (#f '())
+                               ((_ inputs . _) inputs)))
+                     (rest (strip-keyword-arguments
+                            '(#:cargo-inputs #:cargo-development-inputs)
+                            lst)))
+                 (object-list->string
+                  `(,@(if (null? rest)
+                          '()
+                          `((arguments ,(list 'quasiquote rest))))
+                    ,@(if (null? native)
+                          '()
+                          `((native-inputs ,(list 'quasiquote native))))
+                    ,@(if (null? inputs)
+                          '()
+                          `((inputs ,(list 'quasiquote inputs)))))
+                  indent)))))))))))
+
 (define (package-location<? p1 p2)
   "Return true if P1's location is \"before\" P2's."
   (let ((loc1 (package-location p1))
@@ -536,7 +595,7 @@ (define (parse-options)
                        edit-expression))
          (policy   (assoc-ref opts 'input-simplification-policy)))
     (for-each (lambda (package)
-                (simplify-package-inputs package #:policy policy
+                (rewrite-cargo-inputs package #:policy policy
                                          #:edit-expression edit))
               ;; Sort package by source code location so that we start editing
               ;; files from the bottom and going upward.  That way, the
